#!/usr/bin/env ruby1.9

require 'yajit'

def help
  puts "Usage: #$0 (programfile | -e 'command')"
  exit 1
end

dumpyarv = ARGV.delete('-y')
disasm = ARGV.delete('-d')

arg = ARGV.shift
help if !arg

code = nil
if arg == '-e'
  code = ARGV.shift
  help if !code
else
  code = File.read(arg)
end

iseq = VM::InstructionSequence.compile(code)

if dumpyarv
  puts iseq.disasm
  exit(0)
end

jit = Yajit.compile_iseq(iseq)
if jit
  if disasm
    jit.disasm
  else
    jit.call
  end
else
  puts "Failed to compile:"
  puts iseq.disasm
end
