#!/usr/bin/env ruby1.9

require 'yajit'

class YajitFunc
  def to_proc
    s = self
    Proc.new{|*_|s.call(*_)}
  end
end

class Object
  def compile(sym)
    jit_func = Yajit.compile(method(sym))
    self.class.__send__(:define_method, sym, &jit_func)
   end
end

def plus(a, b)
  a + b
end

def plus3(a, b)
  a.+(b)
end

def minus(a, b)
  a - b
end

def minus3(a, b)
  minus(a, b)
end

def plus2(a, b)
  c = a + b
end

def mult(a, b)
  a * b
end

def identity(a)
  a
end

def minus_2(a)
  a - 2
end

def mul(a, b)
  a * b
end

def le(a, b)
  a <= b
end

def min(a, b)
  a <= b ? a : b
end

def int2str(a)
  a.to_s
end

def fib(a)
  a < 2 ? 1 : fib(a-1)+fib(a-2)
end

def factor1(a)
  r = 1
#  s = 0
  #1.upto(a){|i|p i}
  1.upto(a){|i|r *= i}
#  p i
  r
end

def factor2(a)
  r = 1
  for i in 1..a
    r *= i
  end
  r
end

def factor4(a)
  r = 1
  (1..a).each{|i|r *= i}
  r
end

def factor3(a)
  r = 1
  i = 1
  while i <= a
    r *= i
    i += 1
  end
  r
end

def div(a, b)
  a / b
end

def mod(a, b)
  a % b
end

def fizzbuzz
  1.upto(100) do |i|
    if i % 15 == 0
      puts "FizzBuzz"
    elsif i % 5 == 0
      puts "Buzz"
    elsif i % 3 == 0
      puts "Fizz"
    else
      p i
    end
  end
end

def fizzbuzz2
  #"#{1}#{2}"
  #p 'fiz'
  #p ['Fizz'][0]
  #p ['Fizz'][0]
  1.upto(100){|n|puts ["Fizz#{s=[:Buzz][n%5]}"][n%3]||s||n}
end

def double_loop
  s = 0
  3.times{|i|
    3.times{|j|
      p s += i*j
    }
  }
  s
end

def stack_deep
  stack_deep
end

def dp(*a)
  p self, a
  a
end

def func
  r = ''
  1.upto(100) do |i|
    if i % 15 == 0
      r += "FizzBuzz"
    elsif i % 5 == 0
      r += "Buzz"
    elsif i % 3 == 0
      r += "Fizz"
    else
      r += i.to_s
    end
  end
  r
end

C=1
def constant
  C
end

def expandarray
  a, b, x = 3,2
  [a, b, x]
end
compile(:expandarray)
p expandarray

exit

compile(:constant)
p constant

exit

compile(:func)
p func

exit

def each_break
  r = 42
  3.times{|i|
    r += i
    break
  }
  r
end
compile(:each_break)
p each_break

exit

def hoge
  1.times do |a|
    p a
  end
end
compile(:hoge)
p hoge
exit

def many_args(a,b,c,d,e,f,g,h,i)
  p(a,b,c,d,e,f,g,h,i,10,"\n")
  p(a,b,c,d,e,f,g,h,i,10,"\n"){|v|}
end
compile(:many_args)
p many_args(1,2,3,4,5,6,7,8,9)
exit

compile(:stack_deep)
stack_deep

compile(:double_loop)
p double_loop

exit

compile(:plus2)
p plus2('a','b')

compile(:minus)
p minus([1,2],[1])

compile(:mult)
p mult([1,2],',')

compile(:mod)
p mod('%d',3)

exit

puts VM::InstructionSequence.disasm(method(:fizzbuzz2))
STDOUT.flush
compile(:fizzbuzz2)
p fizzbuzz2

exit

puts VM::InstructionSequence.disasm(method(:mod))
STDOUT.flush
compile(:mod)
p mod(7, 3)

puts VM::InstructionSequence.disasm(method(:div))
STDOUT.flush
compile(:div)
p div(23, 4)

exit

puts VM::InstructionSequence.disasm(method(:factor2))
STDOUT.flush
compile(:factor2)
p factor2(4)

exit

puts VM::InstructionSequence.disasm(method(:factor1))
STDOUT.flush
compile(:factor1)
p factor1(10)

exit

compile(:minus)
compile(:minus3)

#p fib(30)

compile(:fib)
#compile(:plus)
#compile(:fib)
p fib(10)
#p minus3(3,4)
#p fib(20)
#p plus(3,4)
#p plus(4,4)
#exit
#puts VM::InstructionSequence.disasm(method(:int2str))
#puts VM::InstructionSequence.disasm(method(:fib))
#p Yajit.compile(method(:minus3)).call(6, 4)
#p Yajit.compile(method(:fib)).call(6)

#exit

#puts VM::InstructionSequence.disasm(method(:plus))
#puts VM::InstructionSequence.disasm(method(:factor))
#puts VM::InstructionSequence.disasm(method(:factor2))
#puts VM::InstructionSequence.disasm(method(:factor3))
puts VM::InstructionSequence.disasm(method(:int2str))
#puts VM::InstructionSequence.disasm(method(:fib))
#puts VM::InstructionSequence.disasm(method(:identity))
#puts VM::InstructionSequence.disasm(method(:minus_2))

#jit_plus = Yajit.compile(method(:plus))
#jit_minus = Yajit.compile(method(:minus))

#jit_identity = Yajit.compile(method(:identity))
#jit_minus_2 = Yajit.compile(method(:minus_2))

jit_mul = Yajit.compile(method(:mul))
#p jit_mul.call(4, 8)

jit_le = Yajit.compile(method(:le))
#p jit_le.call(4, 5)
#p jit_le.call(4, 4)
#p jit_le.call(4, 3)

jit_min = Yajit.compile(method(:min))
#p jit_min.call(3,4)
#p jit_min.call(4,4)
#p jit_min.call(5,4)

jit_factor3 = Yajit.compile(method(:factor3))

#p jit_factor3.call(7)

#jit_minus3 = Yajit.compile(method(:minus3))
#p jit_minus3.call(4, 3)

jit_int2str = Yajit.compile(method(:int2str))
p jit_int2str.call(4)

exit

#puts jit_plus

#p jit_plus.call(2,3)
#p jit_plus.call(-6,3)
#p jit_minus.call(7,-3)

#p jit_identity.call(7)
#p jit_minus_2.call(7)

#p jit_factor3(7)

#puts VM::InstructionSequence.disasm(method(:plus2))

exit

p VM.methods
p VM::USAGE_ANALYSIS_INSN
p VM::USAGE_ANALYSIS_REGS
p VM::USAGE_ANALYSIS_INSN_BIGRAM
p VM::OPTS
p VM::InstructionSequence
p c=VM::InstructionSequence.compile('p "hoge"')
def fib(a)
  a < 2 ? 1 : fib(a-1)+fib(a-2)
end
def plus(a, b)
  a + b
end
puts VM::InstructionSequence.disasm method(:plus)
puts VM::InstructionSequence.disasm method(:fib)
puts c.disasm

