require 'test/base'
require 'yajit'

def plus(a, b)
  a + b
end

def minus(a, b)
  a - b
end

def minus2(a, b)
  minus(a, b)
end

def mult(a, b)
  a * b
end

def int2str(a)
  a.to_s
end

def tostring(a)
  "#{a}"
end

def factor1(a)
  r = 1
  1.upto(a){|i|r *= i}
  r
end

def factor3(a)
  r = 1
  i = 1
  while i <= a
    r *= i
    i += 1
  end
  r
end

def div(a, b)
  a / b
end

def mod(a, b)
  a % b
end

def dummy_puts(*a)
end

def dummy_p(*a)
end

def fizzbuzz
  r = ''
  1.upto(100) do |i|
    if i % 15 == 0
      r += "FizzBuzz"
    elsif i % 5 == 0
      r += "Buzz"
    elsif i % 3 == 0
      r += "Fizz"
    else
      r += i.to_s
    end
  end
  r
end

def fizzbuzz2
  1.upto(100){|n|dummy_puts ["Fizz#{s=[:Buzz][n%5]}"][n%3]||s||n}
end

def create_array
  [1, 2]
end

def create_array3
  []
end

def create_nest_array
  ['1', 2, [3], [], [4,5,[],6,[7],:sym]]
end

def create_hash
  {1 => 3, 2 => 4, 3 => 5, 'a' => {'b' => 'd'}}
end

def aref(a)
  a[1]
end

def concat_str
  "#{1}#{2}#{[]}"
end

def regexp1(str)
  /b/ =~ str
end

def regexp2(str)
  str =~ /b/
end

def toregexp
  / #{1} #{2} /i
end

def not(o)
  !o
end

def succ(a)
  a.succ
end

def length(a)
  a.length
end

def aset(a, b)
  a[1] = b
  a
end

def ltlt(a, b)
  a << b
end

def eq(a, b)
  a == b
end

def neq(a, b)
  a != b
end

def le(a, b)
  a <= b
end

def lt(a, b)
  a < b
end

def ge(a, b)
  a >= b
end

def gt(a, b)
  a > b
end

def opt_case(a)
  case a
  when 1
    3
  when 2
    4
  else
    5
  end
end

def dp(*a)
  a
end

def many_args(a,b,c,d,e,f,g,h,i)
  [
   dp("\n"), dp("\n"){|v|},
   dp(a,"\n"), dp(a,"\n"){|v|},
   dp(a,b,"\n"), dp(a,b,"\n"){|v|},
   dp(a,b,c,"\n"), dp(a,b,c,"\n"){|v|},
   dp(a,b,c,d,"\n"), dp(a,b,c,d,"\n"){|v|},
   dp(a,b,c,d,e,"\n"), dp(a,b,c,d,e,"\n"){|v|},
   dp(a,b,c,d,e,f,"\n"), dp(a,b,c,d,e,f,"\n"){|v|},
   dp(a,b,c,d,e,f,g,"\n"), dp(a,b,c,d,e,f,g,"\n"){|v|},
   dp(a,b,c,d,e,f,g,h,"\n"), dp(a,b,c,d,e,f,g,h,"\n"){|v|},
   dp(a,b,c,d,e,f,g,h,i,"\n"), dp(a,b,c,d,e,f,g,h,i,"\n"){|v|},
  ]
end

def create_array2
  [dp(1),dp(2,3,4,5,6,7)]
end

def argc1
  [[1]].each{|a|[a]}
end

def argc2
  [[1,2],[3,4]].each{|a|[a]}
end

def argc3
  [[1,2],[3,4]].each{|a,b|[a,b]}
end

def argc4
  [[1,2],[3,4]].each{|a,b,c|[a,b,c]}
end

def argc5
  [[1,2],[3,4],[5,6,7,8],[9]].each{|a,b,c|[a,b,c]}
end

def set_gvar(a)
  $g = a
end

def get_gvar
  $g
end

def each_break
  r = 42
  9.times{|i|
    r += i
    next if i == 1
    break if i == 2
    r += i
  }
  r
end

CONST = 1
def constant
  CONST
end

def expandarray
  *a = 1
  b, c = 2
  d, e = 2, 3
  f, g = 2, 3, 4
  h, *i = 2
  j, *k = 2, 3
  l, *m = 2, 3, 4
  [a,b,c,d,e,f,g,h,i,j,k,l,m]
end

def concatarray
  [1,*2]
end

def splatarray
  a,b=*[1,2]
  [a,b]
end

def checkincludearray
  a = case 1
      when *1..2
        1
      end
  b = case 0
      when *1..2
        1
      end
  [a,b]
end

class BasicTest < YajitTestCase
  def test_checkincludearray
    assert_jit(:checkincludearray)
  end

  def test_splatarray
    assert_jit(:splatarray)
  end

  def test_concatarray
    assert_jit(:concatarray)
  end

  def test_expandarray
    assert_jit(:expandarray)
  end

  def test_constant
    assert_jit(:constant)
  end

  def test_tostring
    assert_jit(:tostring, 1)
  end

  def test_each_break
    #assert_jit(:each_break)
  end

  def test_global
    assert_jit(:get_gvar)
    assert_jit(:set_gvar, 42)
    assert_jit(:get_gvar)

    Yajit.compile(method(:set_gvar)).call(44)
    assert_equal(44, $g)
  end

  def test_argc
    assert_jit(:argc1)
    assert_jit(:argc2)
    assert_jit(:argc3)
    assert_jit(:argc4)
    assert_jit(:argc5)
  end

  def test_many_args
    assert_jit(:many_args, 1,2,3,4,5,6,7,8,9)
  end

  def test_create_array2
    assert_jit(:create_array2)
  end

  def test_create_array3
    assert_jit(:create_array3)
  end

  def test_case
    assert_jit(:opt_case, 1)
  end

  def test_rel
    assert_jit(:eq, 1, 2)
    assert_jit(:eq, 2, 2)
    assert_jit(:eq, 'a', 'b')
    assert_jit(:eq, 'b', 'b')
    assert_jit(:eq, 'c', 'b')
    assert_jit(:neq, 'a', 'b')
    assert_jit(:neq, 'b', 'b')
    assert_jit(:neq, 'c', 'b')
    assert_jit(:ge, 'a', 'b')
    assert_jit(:ge, 'b', 'b')
    assert_jit(:ge, 'c', 'b')
    assert_jit(:gt, 'a', 'b')
    assert_jit(:gt, 'b', 'b')
    assert_jit(:gt, 'c', 'b')
    assert_jit(:le, 'a', 'b')
    assert_jit(:le, 'b', 'b')
    assert_jit(:le, 'c', 'b')
    assert_jit(:lt, 'a', 'b')
    assert_jit(:lt, 'b', 'b')
    assert_jit(:lt, 'c', 'b')
  end

  def test_ltlt
    assert_jit(:ltlt, 'abc', 'def')
    assert_jit(:ltlt, ['abc'], 'def')
  end

  def test_aset
    assert_jit(:aset, [1,2], 3)
  end

  def test_succ
    assert_jit(:succ, 3)
  end

  def test_length
    assert_jit(:length, [1,2])
    assert_jit(:length, "abc")
  end

  def test_not
    assert_jit(:not, false)
    assert_jit(:not, nil)
    assert_jit(:not, 'abc')
    assert_jit(:not, 3)
    assert_jit(:not, :abs)
  end

  def test_toregexp
    assert_jit(:toregexp)
  end

  def test_regexp1
    assert_jit(:regexp1, 'abc')
  end

  def test_regexp2
    assert_jit(:regexp2, 'abc')
    assert_jit(:regexp2, 'def')
  end

  def test_plus
    assert_jit(:plus, 3, 2)
    assert_jit(:plus, 'abc', 'def')
  end

  def test_minus
    assert_jit(:minus, 3, 2)
    assert_jit(:minus, [1,2,3], [2])
    assert_jit(:minus, [1,2,3], [2,3])
  end

  def test_minus2
    assert_jit(:minus2, 3, 2)
    assert_jit(:minus2, [1,2,3], [2])
    assert_jit(:minus2, [1,2,3], [2,3])
  end

  def test_mult
    assert_jit(:mult, 3, 2)
    assert_jit(:mult, [1,3], ',')
  end

  def test_create_array
    assert_jit(:create_array)
    assert_jit(:create_nest_array)
  end

  def test_create_hash
    assert_jit(:create_hash)
  end

  def test_aref
    assert_jit(:aref, [1,2])
  end

  def test_concat_str
    assert_jit(:concat_str)
  end

  def test_fizzbuzz
    assert_jit(:fizzbuzz)
  end

  def test_fizzbuzz2
    assert_jit(:fizzbuzz2)
  end

  def test_div
    assert_jit(:div, 23, 4)
  end

  def test_mod
    assert_jit(:mod, 23, 4)
    assert_jit(:mod, '%p', 4)
  end

  def test_int2str
    assert_jit(:int2str, 3)
  end

  def test_factor1
    assert_jit(:factor1, 5)
  end

  def test_factor3
    assert_jit(:factor3, 5)
  end
end
